/* eslint-disable react/jsx-props-no-spreading */
import React, { FC, useState } from 'react';
import { Button, TextField } from '@material-ui/core';
import { Control, Controller } from 'react-hook-form';
import { InsertReservationProps } from './InsertReservationProps';

type TripStageProps = {
  control: Control<InsertReservationProps>;
};

// FIX: Data is flushed onChange. Similar problem in seniorSearch.
// What about this https://codesandbox.io/s/usefieldarray-wfbjt?file=/src/index.js
// Usefields.
// https://codesandbox.io/s/usefieldarray-virtual-input-v9wyw
// https://codesandbox.io/s/react-hook-form-usefieldarray-7bpmk
export const TripStage: FC<TripStageProps> = ({ control }: TripStageProps) => {
  const [stage, setStage] = useState<string[]>([]);
  const [value, setValue] = useState<string>('');

  const addStage = (): void => {
    setStage([...stage, value]);
  };

  return (
    <>
      {stage.map((field, index) => (
        <Controller
          as={<TextField />}
          name={`tripStages[${index}].address`}
          control={control}
          defaultValue={field}
        />
      ))}
      <Button variant="outlined" onClick={addStage} type="button">
        Add stage
      </Button>
    </>
  );
};
